import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { Swiper, SwiperParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询轮播图
 */
export async function pageSwiper(params: SwiperParam) {
  const res = await request.get<ApiResult<PageResult<Swiper>>>(
    MODULES_API_URL + '/shop/swiper/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询轮播图列表
 */
export async function listSwiper(params?: SwiperParam) {
  const res = await request.get<ApiResult<Swiper[]>>(
    MODULES_API_URL + '/shop/swiper',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加轮播图
 */
export async function addSwiper(data: Swiper) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/swiper',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改轮播图
 */
export async function updateSwiper(data: Swiper) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/swiper',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除轮播图
 */
export async function removeSwiper(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/swiper/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除轮播图
 */
export async function removeBatchSwiper(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/swiper/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询轮播图
 */
export async function getSwiper(id: number) {
  const res = await request.get<ApiResult<Swiper>>(
    MODULES_API_URL + '/shop/swiper/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
